=== debian/changelog ===
cppad (2017.00.00.4-3) unstable; urgency=medium

  * oops, wrong Div test patch, the right one actually (closes: #860657)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 27 Apr 2017 21:07:40 +0100

cppad (2017.00.00.4-2) unstable; urgency=medium

  * Upstream patch 9794fd4e aka 20170000.5~1 fixes Div test case which fails on
    i386 and arm64 but succeeds on amd64 and armhf (closes: #860657)

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 27 Apr 2017 20:09:39 +0100

cppad (2017.00.00.4-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 26 Apr 2017 15:33:11 +0100

cppad (2017.00.00.3-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Mon, 13 Mar 2017 19:26:30 +0000

cppad (2017.00.00.2-1) unstable; urgency=medium

  * New upstream release

 -- Barak A. Pearlmutter <bap@debian.org>  Thu, 23 Feb 2017 14:09:36 +0000
