=== debian/changelog ===
cppad (2017.00.00.7-1) unstable; urgency=medium

  * New upstream release
  * Remove cherry-picked upstream quilt patch

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 28 Jun 2017 14:41:45 +0100
