## cppad 2017.00.00.8

=== debian/changelog ===
cppad (2017.00.00.8-1) unstable; urgency=medium

  * New upstream release
  * Bump policy
  * Secure URLs in debian/control

 -- Barak A. Pearlmutter <bap@debian.org>  Wed, 06 Dec 2017 15:23:09 +0000
