=== debian/control ===
--- 
+++ 
@@ -5,10 +5,10 @@
 Uploaders: Miles Lubin <miles.lubin@gmail.com>,
            Barak A. Pearlmutter <bap@debian.org>
 Build-Depends: debhelper (>= 10), cmake, libboost-dev
-Standards-Version: 3.9.8
-Homepage: http://www.coin-or.org/CppAD/
-Vcs-Git: git://anonscm.debian.org/debian-science/packages/cppad.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=debian-science/packages/cppad.git
+Standards-Version: 4.1.1
+Homepage: https://projects.coin-or.org/CppAD/
+Vcs-Git: https://anonscm.debian.org/git/debian-science/packages/cppad.git
+Vcs-Browser: https://anonscm.debian.org/gitweb/?p=debian-science/packages/cppad.git
 
 Package: cppad
 Architecture: all
